<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="计划编码" prop="planNo">
        <el-input
          v-model="queryParams.planNo"
          placeholder="请输入计划编码"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="计划名称" prop="planName">
        <el-input
          v-model="queryParams.planName"
          placeholder="请输入计划名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['device:inspection-plan:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['device:inspection-plan:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
        <el-button
            type="danger"
            plain
            :disabled="isEmpty(checkedIds)"
            @click="handleDeleteBatch"
            v-hasPermi="['device:inspection-plan:delete']"
        >
          <Icon icon="ep:delete" class="mr-5px" /> 批量删除
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table
        row-key="id"
        v-loading="loading"
        :data="list"
        :stripe="true"
        :show-overflow-tooltip="true"
        @selection-change="handleRowCheckboxChange"
    >
    <el-table-column type="selection" width="55" />
      <el-table-column label="计划编码" align="center" prop="planNo" width="120" />
      <el-table-column label="计划名称" align="center" prop="planName" width="120"  />
      <el-table-column label="巡检班组" align="center" prop="teamName" width="120"  />
      <el-table-column label="巡检标准" align="center" prop="standardName"/>
      <el-table-column label="班组成员" align="center" prop="teamStaffNames" width="160" />
      <el-table-column label="任务限制工时" align="center" prop="timeoutHour"  width="120" />
      <el-table-column label="超时提醒人" align="center" prop="timeoutReminderName"  width="120" />
      <el-table-column
        label="首次执行时间"
        align="center"
        prop="firstDate"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="下次执行时间"
        align="center"
        prop="secondDate"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="周期方式" align="center" prop="periodType" width="120">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.DEVICE_MAINTENANCE_PERIOD_TYPE" :value="scope.row.periodType" />
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="状态" align="center" prop="state" width="120" fixed="right" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.DEVICE_MAINTENANCE_PLAN_STATE" :value="scope.row.state" />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" min-width="180px" fixed="right" >
        <template #default="scope">
          <el-button
            link
            type="success"
            @click="handleExecute(scope.row.id)"
            v-hasPermi="['device:inspection-plan:execute']"
          >
            执行任务
          </el-button>
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['device:inspection-plan:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['device:inspection-plan:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <InspectionPlanForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { isEmpty } from '@/utils/is'
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { InspectionPlanApi, InspectionPlanVO } from '@/api/device/inspectionplan'
import InspectionPlanForm from './InspectionPlanForm.vue'
import {DICT_TYPE} from "@/utils/dict";

/** 设备巡检计划 列表 */
defineOptions({ name: 'DeviceInspectionPlan' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<InspectionPlanVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  planNo: undefined,
  planName: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await InspectionPlanApi.getInspectionPlanPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await InspectionPlanApi.deleteInspectionPlan(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 批量删除设备巡检计划 */
const handleDeleteBatch = async () => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    await InspectionPlanApi.deleteInspectionPlanList(checkedIds.value);
    message.success(t('common.delSuccess'))
    await getList();
  } catch {}
}

const checkedIds = ref<number[]>([])
const handleRowCheckboxChange = (records: InspectionPlanVO[]) => {
  checkedIds.value = records.map((item) => item.id);
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await InspectionPlanApi.exportInspectionPlan(queryParams)
    download.excel(data, '设备巡检计划.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 执行巡检计划 */
const handleExecute = async (id: number) => {
  try {
    // 执行的二次确认
    await message.confirm('确定要手动执行该巡检计划吗？')
    // 发起执行请求
    await InspectionPlanApi.executeInspectionPlan(id)
    message.success('执行成功')
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
